<?php

namespace WpifyWoo\PacketeraSDK\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ShipmentIdDetail StructType
 * @subpackage Structs
 */
class ShipmentIdDetail extends AbstractStructBase
{
    /**
     * The id
     * @var int
     */
    public $id;
    /**
     * The checksum
     * @var string
     */
    public $checksum;
    /**
     * The barcode
     * @var string
     */
    public $barcode;
    /**
     * The barcodeText
     * @var string
     */
    public $barcodeText;
    /**
     * Constructor method for ShipmentIdDetail
     * @uses ShipmentIdDetail::setId()
     * @uses ShipmentIdDetail::setChecksum()
     * @uses ShipmentIdDetail::setBarcode()
     * @uses ShipmentIdDetail::setBarcodeText()
     * @param int $id
     * @param string $checksum
     * @param string $barcode
     * @param string $barcodeText
     */
    public function __construct($id = null, $checksum = null, $barcode = null, $barcodeText = null)
    {
        $this
            ->setId($id)
            ->setChecksum($checksum)
            ->setBarcode($barcode)
            ->setBarcodeText($barcodeText);
    }
    /**
     * Get id value
     * @return int|null
     */
    public function getId()
    {
        return $this->id;
    }
    /**
     * Set id value
     * @param int $id
     * @return \WpifyWoo\PacketeraSDK\StructType\ShipmentIdDetail
     */
    public function setId($id = null)
    {
        // validation for constraint: int
        if (!is_null($id) && !(is_int($id) || ctype_digit($id))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($id, true), gettype($id)), __LINE__);
        }
        $this->id = $id;
        return $this;
    }
    /**
     * Get checksum value
     * @return string|null
     */
    public function getChecksum()
    {
        return $this->checksum;
    }
    /**
     * Set checksum value
     * @param string $checksum
     * @return \WpifyWoo\PacketeraSDK\StructType\ShipmentIdDetail
     */
    public function setChecksum($checksum = null)
    {
        // validation for constraint: string
        if (!is_null($checksum) && !is_string($checksum)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($checksum, true), gettype($checksum)), __LINE__);
        }
        $this->checksum = $checksum;
        return $this;
    }
    /**
     * Get barcode value
     * @return string|null
     */
    public function getBarcode()
    {
        return $this->barcode;
    }
    /**
     * Set barcode value
     * @param string $barcode
     * @return \WpifyWoo\PacketeraSDK\StructType\ShipmentIdDetail
     */
    public function setBarcode($barcode = null)
    {
        // validation for constraint: string
        if (!is_null($barcode) && !is_string($barcode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($barcode, true), gettype($barcode)), __LINE__);
        }
        $this->barcode = $barcode;
        return $this;
    }
    /**
     * Get barcodeText value
     * @return string|null
     */
    public function getBarcodeText()
    {
        return $this->barcodeText;
    }
    /**
     * Set barcodeText value
     * @param string $barcodeText
     * @return \WpifyWoo\PacketeraSDK\StructType\ShipmentIdDetail
     */
    public function setBarcodeText($barcodeText = null)
    {
        // validation for constraint: string
        if (!is_null($barcodeText) && !is_string($barcodeText)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($barcodeText, true), gettype($barcodeText)), __LINE__);
        }
        $this->barcodeText = $barcodeText;
        return $this;
    }
}
